﻿EnableExplicit

;COMPILER_OPTIONS$ = "/XP /USER"


#EDITOR$ = "D:\EDIT\Notepad++\notepad++.exe" 


Procedure Main()
 Protected pb_file$ = ProgramParameter(0)
 Protected pb_file_dir$ = GetPathPart(pb_file$)
 Protected asm_file$ = pb_file_dir$ + "PureBasic.asm"
 Protected compiler_exe$ = GetEnvironmentVariable("PB_TOOL_Compiler")
 Protected temp$ = GetEnvironmentVariable("TEMP")
 Protected editor_exe$ = #EDITOR$
 Protected compiler 

 Protected options$
 If GetEnvironmentVariable("PB_TOOL_Debugger")="1"
    options$ + " /DEBUGGER"
 EndIf
 If GetEnvironmentVariable("PB_TOOL_InlineASM")="1"
    options$ + " /INLINEASM"
 EndIf
 If GetEnvironmentVariable("PB_TOOL_Unicode")="1"
    options$ + " /UNICODE"
 EndIf
 If GetEnvironmentVariable("PB_TOOL_Thread")="1"
    options$ + " /THREAD"
 EndIf
 If GetEnvironmentVariable("PB_TOOL_XPSkin")="1"
    options$ + " /XP"
 EndIf
 If GetEnvironmentVariable("PB_TOOL_OnError")="1"
    options$ + " /LINENUMBERING"
 EndIf

 If GetEnvironmentVariable("PB_TOOL_SubSystem")<>""
    options$ + " /SUBSYSTEM " + GetEnvironmentVariable("PB_TOOL_SubSystem")
 EndIf

;options$ + " /DLL"

 
 DeleteFile(asm_file$)
 DeleteFile(temp$ + "\PB_Commented.exe")

 If (Len(pb_file$) > 0 And FileSize(pb_file$) > 0)    
    ; the asm file is created in the working dir
    compiler = RunProgram(compiler_exe$, Chr(34) + pb_file$ + Chr(34)+" /COMMENTED /EXE " + temp$ + "\PB_Commented.exe " + options$, pb_file_dir$, #PB_Program_Hide | #PB_Program_Wait)

    If compiler         
        If FileSize(asm_file$) >= 0
            RunProgram(editor_exe$, asm_file$,"")
        Else
            MessageRequester("ASM source not found !", Chr(34) + asm_file$ + Chr(34) + " not found.")
        EndIf        
    EndIf
    DeleteFile(temp$ + "\PB_Commented.exe")
 Else
    MessageRequester("PB source not found !", Chr(34) + pb_file$ + Chr(34) + " not found.")         
 EndIf
 
EndProcedure

Main()

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 41
; Folding = -
; EnableUnicode
; EnableXP
; Executable = CommentedASM.exe
; CPU = 5
; DisableDebugger
; CompileSourceDirectory